//+------------------------------------------------------------------+
//|                                   Lawgirl's Trend Display EA.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#define up "Up"
#define down "Down"
#define flat "Flat"


extern string  PairsToTrade = "AUDCAD,AUDCHF,AUDNZD,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURNZD,EURJPY,EURUSD,GBPCHF,GBPJPY,GBPUSD,NZDUSD,NZDJPY,USDCAD,USDCHF,USDJPY";
extern string  lb="----Look back inputs----";
extern int     LookBackCandles=1;
extern double  MinimumValueChange=1;
extern bool    TrendRequiresAllThree=true;
extern bool    TrendRequiresOnlyHtf=false;
extern bool    AlertByEmail=true;
extern string  pci="----Pair display inputs----";
extern int     FontSize=10;
extern color   PairColour=Yellow;
extern color   LongColour=Green;
extern color   ShortColour=Red;
extern color   FlatColour=Blue;
extern double  DisplayStartsAtRow=80;
extern double  RowSpacing=60;
extern double  DisplayStartsAtCol=2.2;
extern double  ColumnSpacing=1.2;
extern bool    DisplayMN1=true;


//Pair extraction
string         InputString;//Holds the contents PairsToTrade for tidying yp etc
string         OldInputString;//For comparison, in case the user has made a change
int            NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string         TradePair[]; //Array to hold the pairs traded by the user
bool           AlertSent[];

string         trend;
double         H4, pH4, D1, pD1, W1, pW1, MN1, pMN1;//Rsi values
int            OldBars;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
   //Extract the pairs traded by the user
   ExtractPairs();
   OldInputString = InputString;
   start();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    Comment("");
    ObjectsDeleteAll(0, OBJ_LABEL);
    return(0);

//----
   return(0);
  }

void ExtractPairs()
{
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   bool NewArray1  = ArrayResize(AlertSent, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)



}//End void ExtractPairs()


void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   NoOfPairs = 0;
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()


void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

double ReadRsi(string symbol, int tf, int shift)
{

   return(iRSI(symbol, tf, 3, PRICE_CLOSE, shift) );
   

}//double ReadRsi(string symbol, int tf)


void Get_Trend(string symbol)
{

//extern bool    TrendRequiresAllThree=true;
//extern bool    TrendRequiresOnlyHtf=false;
   
   trend = flat;

   if (TrendRequiresAllThree)
   {
      if ( 
            (H4 > pH4 && H4 - pH4 > MinimumValueChange) &&
            (D1 > pD1 && D1 - pD1 > MinimumValueChange) &&
            (W1 > pW1 && W1 - pW1 > MinimumValueChange)
         )trend = up;
      
      if ( 
            (H4 < pH4 && pH4 - H4 > MinimumValueChange) &&
            (D1 < pD1 && pD1 - D1 > MinimumValueChange) &&
            (W1 < pW1 && pW1 - W1 > MinimumValueChange)
         )trend = down;
   }//if (TrendRequiresAllThree)
   
   if (TrendRequiresOnlyHtf)
   {
      if ( 
            (D1 > pD1 && D1 - pD1 > MinimumValueChange) &&
            (W1 > pW1 && W1 - pW1 > MinimumValueChange)
         )trend = up;
      
      if ( 
            (D1 < pD1 && pD1 - D1 > MinimumValueChange) &&
            (W1 < pW1 && pW1 - W1 > MinimumValueChange)
         )trend = down;
   }//if (TrendRequiresOnlyHtf)
   
      
      
}//End void Get_Trend(string symbol)


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

   if (OldInputString != InputString)
   {
      ExtractPairs();
      OldInputString = InputString;
   }//if (OldInputString != InputString)
   
   
   if (OldBars == Bars) return;
   OldBars = Bars;

   
   double vertical = DisplayStartsAtCol;
   vertical+= ColumnSpacing;
   double horizontal;
   string Label_Name;


   //Headings
   horizontal = DisplayStartsAtRow + 100;
   vertical+= ColumnSpacing;         
   Label_Name = "headlabel"+"d";
   Printtxt("Trend",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= RowSpacing;
         
   Label_Name = "headlabel"+"a";
   Printtxt("M240",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= RowSpacing;
         
   Label_Name = "headlabel"+"b";
   Printtxt("D1",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= RowSpacing;
         
   Label_Name = "headlabel"+"c";
   Printtxt("W1",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
   horizontal+= RowSpacing;

   if (DisplayMN1)
   {         
      Label_Name = "headlabel"+"e";
      Printtxt("MN1",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
      horizontal+= RowSpacing;
   }//if (DisplayMN1)
            

      
   //Pairs
   for (int cc = 0; cc < NoOfPairs; cc++)
   {
      string symbol = TradePair[cc];

         
      H4 = ReadRsi(symbol, PERIOD_H4, 0);
      pH4 = ReadRsi(symbol, PERIOD_H4, LookBackCandles);
   
      D1 = ReadRsi(symbol, PERIOD_D1, 0);
      pD1 = ReadRsi(symbol, PERIOD_D1, LookBackCandles);
      
      
      W1 = ReadRsi(symbol, PERIOD_W1, 0);
      pW1 = ReadRsi(symbol, PERIOD_W1, LookBackCandles);
   
      if (DisplayMN1)
      {
         MN1 = ReadRsi(symbol, PERIOD_MN1, 0);
         pMN1 = ReadRsi(symbol, PERIOD_MN1, LookBackCandles);
      }//if (DisplayMN1)
      


      Get_Trend(symbol);
      if (AlertByEmail)
      {
         if (trend == flat) AlertSent[cc] = false;
         
         if (trend == up && !AlertSent[cc] )
         {
            SendMail("lawgirl trend notification", symbol + " " + trend + " trend is in place. " + TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES));
            AlertSent[cc] = true;
         }//if (trend == up && !AlertSent[cc] )
         
         if (trend == down && !AlertSent[cc] )
         {
            SendMail("lawgirl trend notification", symbol + " " + trend + " trend is in place. " + TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES));
            AlertSent[cc] = true;
         }//if (trend == down && !AlertSent[cc] )
         
      
      }//if (AlertByEmail)
      
      //Trend
      horizontal = DisplayStartsAtRow;
      color v_color=Yellow;
      vertical+= ColumnSpacing;
      Label_Name = "mylabel"+DoubleToStr(cc,0);
      Printtxt(symbol,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
      horizontal+= 100;

      string thisone;
      thisone = flat; 
      v_color = FlatColour;
      if (trend == up) 
      {
         thisone = up; 
         v_color = LongColour;
      }//if (trend == up) 
      
      if (trend == down) 
      {
         thisone = down; 
         v_color = ShortColour;
      }//if (trend == up) 
      
      Label_Name = "mylabel"+DoubleToStr(cc,0) +"a";
      Printtxt(thisone, Label_Name, FontSize,"Arial", v_color,vertical,horizontal);
      horizontal+= RowSpacing;

      //H4
      thisone = flat; 
      v_color = FlatColour;
      if (H4 > pH4 && H4 - pH4 > MinimumValueChange)
      {
         thisone = up; 
         v_color = LongColour;
      }//if (H4 > pH4 && H4 - pH4 > MinimumValueChange )
      
      if (H4 < pH4 && pH4 - H4 > MinimumValueChange)
      {
         thisone = down; 
         v_color = ShortColour;
      }//if (H4 < pH4 && pH4 - H4 > MinimumValueChange)
      
      Label_Name = "mylabel"+DoubleToStr(cc,0) +"b";
      Printtxt(thisone, Label_Name, FontSize,"Arial", v_color,vertical,horizontal);
      horizontal+= RowSpacing;

      //D1
      thisone = flat; 
      v_color = FlatColour;
      if (D1 > pD1 && D1 - pD1 > MinimumValueChange)
      {
         thisone = up; 
         v_color = LongColour;
      }//if (D1 > pD1 && D1 - pD1 > MinimumValueChange )
      
      if (D1 < pD1 && pD1 - D1 > MinimumValueChange)
      {
         thisone = down; 
         v_color = ShortColour;
      }//if (D1 < pD1 && pD1 - D1 > MinimumValueChange)
      
      Label_Name = "mylabel"+DoubleToStr(cc,0) +"c";
      Printtxt(thisone, Label_Name, FontSize,"Arial", v_color,vertical,horizontal);
      horizontal+= RowSpacing;

      //W1
      thisone = flat; 
      v_color = FlatColour;
      if (W1 > pW1 && W1 - pW1 > MinimumValueChange)
      {
         thisone = up; 
         v_color = LongColour;
      }//if (W1 > pW1 && W1 - pW1 > MinimumValueChange )
      
      if (W1 < pW1 && pW1 - W1 > MinimumValueChange)
      {
         thisone = down; 
         v_color = ShortColour;
      }//if (W1 < pW1 && pW1 - W1 > MinimumValueChange)
      
      Label_Name = "mylabel"+DoubleToStr(cc,0) +"d";
      Printtxt(thisone, Label_Name, FontSize,"Arial", v_color,vertical,horizontal);
      horizontal+= RowSpacing;

      //MN1
      if (DisplayMN1)
      {
         thisone = flat; 
         v_color = FlatColour;
         if (MN1 > pMN1 && MN1 - pMN1 > MinimumValueChange)
         {
            thisone = up; 
            v_color = LongColour;
         }//if (MN1 > pMN1 && MN1 - pMN1 > MinimumValueChange )
      
         if (MN1 < pMN1 && pMN1 - MN1 > MinimumValueChange)
         {
            thisone = down; 
            v_color = ShortColour;
         }//if (MN1 < pMN1 && pMN1 - MN1 > MinimumValueChange)
      
         Label_Name = "mylabel"+DoubleToStr(cc,0) +"e";
         Printtxt(thisone, Label_Name, FontSize,"Arial", v_color,vertical,horizontal);
         horizontal+= RowSpacing;
      }//if (DisplayMN1)
      
      
   }//for (int cc = 0; cc < NoOfPairs; cc++)
      

}//End start()
//+------------------------------------------------------------------+